unit funi1;

interface

uses crt,graph,dos;

type Konst=array[1..4] of real;

var Attivo:boolean;
    controlmem,numsess:text;
    stfile:string[80];
    bsess:boolean;
    sessione:longint;
    chinutile:char;

function DiskWriteClose(var fila:text):boolean;
function Maiusc(st:string):string;
function controlla (st:string):boolean;
procedure sceglicol(col:word);
procedure numero(x,j:integer;old,r:real;dim:boolean);
procedure sopra(x,y:integer;fonte,size:word;st:string;testo,sfondo:word);
procedure sopramem(x,y:integer;st:string;var taglia:word;var p:pointer;
                   var xput,yput:integer);
procedure percent;
procedure lamp(x,y:integer);
procedure riquadro(xs,ys,xd,yd:integer);
procedure Gread(x,y:integer;var st:string;color:word);
procedure readreal(var num:real);
procedure readint(var num:integer);
function stri (c:real):string;
function stri2 (c:real):string;
function stcoeff(r:real;st:string):string;
function stnoto(r:real):string;
function stfine(r:real;st:string):string;
function stsign(r,p:real):string;
function stzero(c1,c2,c3,c4:real):string;
function fracoeff(r:real):string;
function tipo (ch:char;c:Konst):string;
procedure pres(var Verr:boolean;path:string);
procedure sfondo;
procedure fine;
procedure terna(Var ch:char);
procedure legenda(var ch:char);
procedure inizializza(var Err:boolean;path:string);
procedure sotto(fonte:word;st:string;col:word;dim:integer);

implementation

procedure sceglicol(col:word);
begin                           {Seleziona il colore in funzione della}
  if col<=7 then col:=col+8;    {quota usando solo colori brillanti   }
  setcolor(col);
end;

procedure numero(x,j:integer;old,r:real;dim:boolean);
var p:pointer;
    st:string;                  {Stampa la quota sul video eliminando}
    lung:integer;               {quella precedente                   }
    size:word;
begin
  st:='[z='+stri(R)+']';
  if dim then lung:=length('[z='+stri(old)+']')
         else lung:=length(st);
  setactivepage(1);
  cleardevice;
  outtextxy(x,10+j*10,st);
  size:=imagesize(x,j+2,x+lung*6,j+10);
  getmem(P,size);
  getimage(x,j+2,x+lung*6,j+10,p^);
  setactivepage(0);
  putimage(x,j+2,P^,normalput);
  freemem(P,size);
end;


function DiskWriteClose(var fila:text):boolean;
{fila deve essere gi stato assegnato}
var Err:boolean;
begin
  {$I-}
  rewrite(fila);
  if ioresult<>0 then Err:=true
                 else Err:=false;
  {$I+}
  if not Err then close(fila);
  DiskWriteClose:=Err;
end;

function Maiusc(st:string):string;
var i:integer;
begin
  for i:=1 to length(st) do st[i]:=UpCase(st[i]);
  Maiusc:=st;
end;

function controlla (st:string):boolean;
var
  S: PathStr;                   {D true se trova il file st}
begin
  S := FSearch(st,GetEnv(''));
  if S = '' then
  begin
    controlla:=false;
  end
  else controlla:=true;
end;

procedure sopra(x,y:integer;fonte,size:word;st:string;testo,sfondo:word);
var port:viewporttype;
    textinfo:textsettingstype;
    oldcolor:word;
    oldfill:fillsettingstype;
    lung,larg:integer;

begin
  oldcolor:=getcolor;
  getfillsettings(oldfill);
  getviewsettings(port);
  gettextsettings(textinfo);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  settextstyle(fonte,horizdir,size);
  setfillstyle(solidfill,sfondo);
  settextjustify(centertext,centertext);
  lung:=textwidth(st)+4;
  larg:=textheight(st)+2;
  bar(x-lung div 2,y-larg div 2,x+lung div 2,y+larg div 2+1);
  setcolor(red);
  rectangle(x-lung div 2-1,y-larg div 2-1,x+lung div 2+1,y+larg div 2+2);
  setcolor(testo);
  outtextxy(x,y,st);
  with port do setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextstyle(font,direction,charsize);
    settextjustify(horiz,vert);
  end;
  with oldfill do setfillstyle(pattern,color);
  setcolor(oldcolor);
end;

procedure sopramem(x,y:integer;st:string;var taglia:word;var p:pointer;
                   var xput,yput:integer);
var larg,lung:integer;
    textinfo:textsettingstype;
begin
  gettextsettings(textinfo);
  settextstyle(smallfont,horizdir,4);
  lung:=textwidth(st)+4;
  larg:=textheight(st)+2;
  taglia:=imagesize(x-lung div 2-1,y-larg div 2-1,x+lung div 2+1,y+larg div 2+2);
  getmem(p,taglia);
  getimage(x-lung div 2-1,y-larg div 2-1,x+lung div 2+1,y+larg div 2+2,p^);
  sopra(x,y,smallfont,4,st,yellow,blue);
  xput:=x-lung div 2-1;
  yput:=y-larg div 2-1;
  with textinfo do
  settextstyle(font,direction,charsize);
end;

procedure percent;
const maxcifre=5;
var st:string;
    nowmem:longint;
    port:viewporttype;
    i,fin:integer;
begin
  if Attivo then
  begin
    getviewsettings(port);
    setviewport(0,0,getmaxx,getmaxy,clipon);
    nowmem:=memavail;
    str(nowmem div 1024,st);
    fin:=maxcifre-length(st);
    if fin<1 then fin:=1;
    for i:=1 to fin do st:=' '+st;
    st:='Mem: '+st+'Kb';
    sopra(595,15,smallfont,4,st,yellow,blue);
    with port do setviewport(x1,y1,x2,y2,clip);
  end
end;

procedure attendi(time:integer);
var i:integer;
begin
  i:=0;
  while (i<time) and not keypressed do
  begin
    delay(2);
    i:=i+1;
  end;
end;

procedure riquadro(xs,ys,xd,yd:integer);
var port:viewporttype;
begin                          {Disegna un riquadro nero (cord. assolute)}
  getviewsettings(port);
  setviewport(xs,ys,xd,yd,clipon);
  clearviewport;
  with port do
  setviewport(x1,y1,x2,y2,clip);
end;


procedure lamp(x,y:integer);
var time:integer;
    info:textsettingstype;    {Emula il cursore lampeggante del modo testo}
    color:word;
begin
  time:=50;
  color:=getcolor;
  gettextsettings(info);
  settextstyle(defaultfont,horizdir,1);
  repeat
    setcolor(white);
    outtextxy(x,y,'_');
    attendi(time);
    setcolor(black);
    outtextxy(x,y,'_');
    attendi(time)
  until keypressed;
  setcolor(black);
  outtextxy(x,y,'_');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;

procedure Gread(x,y:integer;var st:string;color:word);

const maxcar=25;
type parola=array[1..maxcar] of char;
var cx,cy,i:integer;
    textinfo:textsettingstype;       {Procedura di lettura da tastiera}
    sttemp:string;
    par:parola;
    ch:char;
    oldcolor:word;

procedure ini(var par:parola);
var i:integer;
begin                                {Inizializza la parola a tanti #1}
  for i:=1 to maxcar do
  par[i]:=#1;
end;

function noalfa(ch:char):boolean;
begin                                    {D true se il carattere non}
  if (ord(ch)<32) then noalfa:=true      { stampabile               }
                  else noalfa:=false;
end;

procedure cancella(var i,cx,cy:integer;var par:parola);
var sttemp:string;
    port:viewporttype;
    tcx,tcy:integer;                {Simula l'azione del backspace}
begin
  getviewsettings(port);
  if i>=1 then
  begin
    sttemp:=ch;
    par[i]:=#1;
    i:=i-1;
    cx:=cx-textwidth(sttemp);
    with port do
    begin
      tcx:=cx+x1;
      tcy:=cy+y1;
    end;
    riquadro(tcx,tcy-textheight(sttemp),tcx+textwidth(sttemp),tcy+(
    textheight(sttemp) div 2));
  end;
end;

procedure partra(par:parola;var st:string);
var i:integer;
begin
  st:='';                           {Trasforma l'array parola in stringa}
  for i:=1 to maxcar do
  begin
    if par[i]<>#1 then st:=st+par[i];
  end;
end;

{Inizio Procedura Principale}

begin
  oldcolor:=getcolor;
  gettextsettings(textinfo);
  settextjustify(0,centertext);
  settextstyle(defaultfont,horizdir,1);
  setcolor(color);
  ini(par);
  i:=0;
  cx:=x;
  cy:=y;
  ch:=ReadKey;
  while (ch<>#13) and ((i<maxcar+1) and (ch=#8) or (i<maxcar)) do
  begin
    if not noalfa(ch) then
    begin
      i:=i+1;
      par[i]:=ch;
      sttemp:=ch;
      outtextxy(cx,cy,sttemp);
      cx:=cx+textwidth(sttemp);
    end
    else
      if (ch=#8) then cancella(i,cx,cy,par)
                 else begin
                        sound(500);
                        delay(100);
                        nosound;
                      end;
    lamp(cx,cy);
    ch:=ReadKey;
  end;
  partra(par,st);
  setcolor(oldcolor);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;


procedure readreal(var num:real);
var x,y:integer;
    Err:boolean;
begin
  x:=wherex;                    {Legge un reale prevenendo errori di I/O}
  y:=wherey;
  {$I-}
  repeat
    readln(num);
    Err:=ioresult<>0;
    if Err then
    begin
      write(#7);
      gotoxy(x,y);
      write(' ':50);
      gotoxy(x,y);
    end;
  until not Err;
  {$I+}
end;

procedure readint(var num:integer);
var x,y:integer;
    Err:boolean;
begin
  x:=wherex;                    {Legge un intero prevenendo errori di I/O}
  y:=wherey;
  {$I-}
  repeat
    readln(num);
    Err:=ioresult<>0;
    if Err then
    begin
      write(#7);
      gotoxy(x,y);
      write(' ':50);
      gotoxy(x,y);
    end;
  until not Err;
  {$I+}
end;

function stri (c:real):string;
var st:string;
begin
  str(c:3:1,st);                 {Trasforma un numero reale in stringa}
  stri:=st;
end;

function stri2 (c:real):string;
var st:string;                      {Trasforma un numero reale in stringa  }
begin                               {mettendo i decimali solo se necessario}
  if frac(c)=0 then str(c:1:0,st)
                else str(c:3:1,st);
  stri2:=st;
end;

procedure inizializza (var Err:boolean;path:string);
var grdriver:integer;
    grmode:integer;              {Inizializza la grafica}
    grerr:integer;
begin
  detectgraph(grdriver,grmode);
  if grdriver=vga then
  begin
    grmode:=vgamed;
    grdriver:=vga;
  end;
  initgraph(grdriver,grmode,path);
  grerr:=graphresult;
  if (grerr=grOk) and ((grdriver=vga) or (grdriver=ega)) then Err:=false
                                                         else Err:=true;
end;

procedure sotto(fonte:word;st:string;col:word;dim:integer);
var info:textsettingstype;
    color:word;
    oldport:viewporttype;
begin                               {stampa "st" nel riquadro secondario}
  getTextsettings(info);
  getviewsettings(oldport);
  color:=getcolor;
  setviewport(81,281,559,329,clipon);
  clearviewport;
  setcolor(col);
  settextstyle(fonte,Horizdir,dim);
  settextjustify(centertext,centertext);
  outtextxy(240,20,st);
  setcolor(color);
  with info do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  with oldport do
  setviewport(x1,y1,x2,y2,clip);
end;

procedure legenda(var ch:char);
var textinfo:textsettingstype;
    color:word;
                                {Mostra la legenda}
begin
  color:=getcolor;
  gettextsettings(textinfo);
  settextjustify(0,0);
  sotto(triplexfont,'Legenda',green,4);
  clearviewport;
  setcolor(white);
  line(10,14,60,14);
  line(10,18,60,18);
  setcolor(lightred);
  line(10,34,60,34);
  line(10,38,60,38);
  setcolor(lightgreen);
  line(10,54,60,54);
  line(10,58,60,58);
  setcolor(lightmagenta);
  line(10,94,60,94);
  line(10,98,60,98);
  setcolor(lightcyan);
  line(10,134,60,134);
  line(10,138,60,138);
  setcolor(white);
  outtextxy(10,20,'       : Spigoli del solido');
  outtextxy(10,40,'       : Assi coordinati solidali al moto rigido');
  outtextxy(10,60,'       : Asse istantaneo di moto');
  outtextxy(10,80,'         e polare fissa');
  outtextxy(10,100,'       : Proiezione degli assi cartesiani sul piano ');
  outtextxy(10,120,'         orizzontale che individua le polari');
  outtextxy(10,140,'       : Polare solidale ed Assi coordinati fissi');
  setcolor(color);
  with textinfo do
  settextjustify(horiz,vert);
  ch:=readkey;
  clearviewport;
end;

procedure terna(var ch:char);
var color:word;
                                     {Mostra la terna fissa}
begin
  color:=getcolor;
  setcolor(lightgreen);
  setTextJustify(0,0);
  settextstyle(defaultfont,horizdir,1);
  line(60,150,60,20);
  outtextxy(70,20,'Z');
  line(60,150,250,150);
  outtextxy(260,160,'X');
  line(60,150,125,95);
  outtextxy(135,95,'Y');
  setcolor(white);
  outtextxy(170,50,'Orientamento del');
  outtextxy(170,70,'sistema di riferimento');
  outtextxy(170,90,'fisso.');
  setTextjustify(centertext,bottomtext);
  sotto(triplexfont,'Terna cartesiana',lightmagenta,3);
  ch:=readkey;
  setcolor(color);
end;

procedure sfondo;

const
  destra=7;
  Patterns : array[0..11] of FillPatternType = (
  (0, $7F, $3C, $18, $25, $33, $4, 1),
  ($33, $33, $CC, $CC, $33, $33, $CC, $CC),
  ($F0, $F0, $F0, $F0, $F, $F, $F, $F),
  (0, $10, $28, $44, $28, $10, 0, 0),
  (0, $70, $20, $27, $25, $27, $4, $4),
  (0, 0, 0, $18, $18, 0, 0, 0),
  (0, 0, $3C, $3C, $3C, $3C, 0, 0),
  (0, $7E, $7E, $7E, $7E, $7E, $7E, 0),
  (0, 0, $22, $8, 0, $22, $1C, 0),
  ($FF, $7E, $3C, $18, $18, $3C, $7E, $FF),
  (0, $10, $10, $7C, $10, $10, 0, 0),
  (0, $42, $24, $18, $18, $24, $42, 0));

var info:Textsettingstype;
    FillInfo: FillSettingsType;
    color,bk:word;                 {Disegna lo sfondo del video}
    st:string;
    x:integer;
begin
  getTextsettings(info);
  getfillsettings(fillinfo);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  color:=getcolor;
  bk:=getbkcolor;
  setbkcolor(black);
  setcolor(lightred);
  rectangle(1,1,getmaxx-1,getmaxy-1);
  rectangle(3,3,getmaxx-3,getmaxy-3);
  setfillpattern(patterns[0],lightmagenta);
  bar(4,4,getmaxx-4,getmaxy-4);
  rectangle(100,50,540,230);
  rectangle(80,280,560,330);
  with fillinfo do
  setfillstyle(11,lightmagenta);
  bar(90,40,550,49);
  bar(90,50,99,240);
  bar(541,50,550,240);
  bar(100,231,540,240);
  rectangle(90,40,550,240);
  setviewport(101,51,539,229,clipon);
  clearviewport;
  setcolor(lightcyan);
  sotto(triplexfont,'',lightmagenta,3);
  if bsess then
  begin
    str(sessione,st);
    st:=' Sessione N '+st+' ';
    x:=(length(st) div 2)*6 +4+destra;
    sopra(x,15,smallfont,4,st,yellow,blue);
  end;
  setbkcolor(bk);
  setcolor(color);
  with info do
  setTextStyle(font,direction,charsize);
  with fillinfo do
  setFillStyle(pattern,color);
end;

procedure pres(var Verr:boolean;path:string);
var x1,y1,x2,y2,i,j:integer;
    info:Textsettingstype;           {Presentazione iniziale}
    FillInfo: FillSettingsType;
    Err:boolean;
    ch:char;
    color,bk:word;

begin
  getTextsettings(info);
  getfillsettings(fillinfo);
  inizializza(Verr,path);
  if not Verr then
  begin
    color:=getcolor;
    sfondo;
    setcolor(lightcyan);
    setTextjustify(centertext,bottomtext);
    settextstyle(gothicfont,Horizdir,5);
    OuttextXy(220,70,'Asse istantaneo');
    OuttextXy(220,130,'di moto');
    sotto(triplexfont,'By Marco Martiri',lightmagenta,3);
    ch:=readkey;
    if ch<>#27 then
    begin
      clearviewport;
      settextstyle(Triplexfont,Horizdir,4);
      outtextXY(220,50,'Studio di un moto');
      outtextXY(220,80,'rigido tridimensionale');
      outtextXY(220,110,'in proiezione prospettica');
      outtextXY(220,140,'od assonometrica.');
      sotto(triplexfont,'Universit di Ancona',white,3);
      ch:=readkey;
    end;
    setcolor(color);
  end
  else
  begin
     closegraph;
     writeln;
     writeln;
     writeln('Scheda video insufficiente (richiesta almeno EGA)');
     writeln('o drivers video non trovati nella directory indicata.');
     writeln('''Asse Istantaneo di Moto'' non pu funzionare.');
  end;
end;

function fracoeff(r:real):string;

begin
  if (r=1) then fracoeff:='1'
           else fracoeff:='';
end;

function stcoeff(r:real;st:string):string;

begin                                  {Scrive il coeff. di un parametro}
  if (r=0) then stcoeff:=''
           else if (r=1) then stcoeff:=st
                         else if (r=-1) then stcoeff:='-'+st
                                        else stcoeff:=stri2(r)+st;
end;

function stnoto(r:real):string;

begin                            {Scrive un termine noto<>0}
  if (r=0) then stnoto:=''
           else stnoto:=stri2(r);
end;

function stfine(r:real;st:string):string;

begin
  if (r=0) then stfine:=''        {Scrive st se r<>0}
           else stfine:=st;
end;

function stsign(r,p:real):string;
                                   {Mette + o - tra due numeri}
begin
  if ((r=0) and (p=0)) or ((r<>0) and (p=0)) or ((r=0) and (p<>0)) then stsign:=''
     else if (r<>0) and (p>0) then stsign:='+'
          else if (r<>0) and (p<0) then stsign:='';
end;

function stzero(c1,c2,c3,c4:real):string;  {Scrive 0 se la funzione }
                                           {identicamente nulla      }
begin
  if (c1=0) and (c2=0) and (c3=0) and (c4=0) then stzero:='0'
                                             else stzero:='';
end;

procedure fine;
var x1,y1,x2,y2,i,j:integer;           {Schermata finale}
    info:Textsettingstype;
    FillInfo: FillSettingsType;
    Err:boolean;
    ch:char;
    color,bk:word;

begin
  setcolor(lightcyan);
  setTextjustify(centertext,bottomtext);
  settextStyle(gothicfont,horizdir,7);
  outtextxy(220,100,'Fine Sessione');
  sotto(triplexfont,'Asse istantaneo di Moto by Marco Martiri',lightmagenta,2);
  ch:=readkey;
  setviewport(0,0,getmaxX,getmaxY,clipon);
  cleardevice;
end;

function tipo (ch:char;c:Konst):string;

begin
  case ch of
  'L':tipo:=stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+stzero(c[1],c[2],c[3],c[4]);
  'Q':tipo:=stcoeff(c[1],'t')+stsign(c[1],c[2])+stcoeff(c[2],'t')+stsign(c[2],c[3])+stnoto(c[3])
             +stzero(c[1],c[2],c[3],c[4]);
  'S':tipo:=stcoeff(c[3],'sen('+stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+
            stzero(c[1],c[2],0,0)+stfine(c[3],')'))+stsign(c[3],c[4])+stnoto(c[4])+
            stzero(0,0,c[3],c[4]);
  'C':tipo:=stcoeff(c[3],'cos('+stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+
            stzero(c[1],c[2],0,0)+stfine(c[3],')'))+stsign(c[3],c[4])+stnoto(c[4])+
            stzero(0,0,c[3],c[4]);
  'E':tipo:=stcoeff(c[3],'esp('+stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+
            stzero(c[1],c[2],0,0)+stfine(c[3],')'))+stsign(c[3],c[4])+stnoto(c[4])+
            stzero(0,0,c[3],c[4]);
  'N':tipo:=stcoeff(c[3],'ln('+stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+
            stzero(c[1],c[2],0,0)+stfine(c[3],')'))+stsign(c[3],c[4])+stnoto(c[4])+
            stzero(0,0,c[3],c[4]);
  'F':tipo:=fracoeff(c[3])+stcoeff(c[3],'/('+stcoeff(c[1],'t')+stsign(c[1],c[2])+stnoto(c[2])+
            stzero(c[1],c[2],0,0)+stfine(c[3],')'))+stsign(c[3],c[4])+
            stnoto(c[4])+stzero(0,0,c[3],c[4]);
  end;
end;


{Assegnamento variabili booleane globali}

begin
  Assign(Numsess,'num.uty');
  if controlla('cmem.uty') then
  begin
    Assign(controlmem,'cmem.uty');
    reset(controlmem);
    readln(controlmem,stfile);
    if stfile='File di controllo della finestra di memoria libera'
    then readln(controlmem,stfile);
    Attivo:=stfile='Mem-On';
    readln(controlmem,stfile);
    bsess:=stfile='Num-On';
    close(controlmem);
  end
  else
  begin
    Attivo:=false;
    bsess:=false;
  end;
  if not controlla('num.uty') then sessione:=1
  else
  begin
    reset(numsess);
    {$I-}
    read(numsess,sessione);
    if ioresult<>0 then sessione:=1;
    {$I+}
    close(numsess);
  end;

  if bsess and DiskWriteClose(numsess) then
  begin
    clrscr;
    writeln('Disco protetto, o errore generale di scrittura:');
    writeln('non  possibile aggiornare il numero della sessione.');
    writeln('Premere un tasto per continuare');
    chinutile:=readkey;
  end
  else if not DiskWriteClose(numsess) then
  begin
    rewrite(numsess);
    if not (sessione < maxlongint) then sessione:=0;
    write(numsess,sessione+1);
    close(numsess);
  end;

end.