unit funi2;

interface

uses graph,dos,crt,funi1;

const corr2=0.7292;
      Enum=10;
type mist=array[1..Enum] of integer;
     punto3D=record
                x:real;
                y:real;
                z:real;
              end;
     listadir=^dir;
     dir=record
           nome:string[13];
           succ:listadir;
         end;

procedure selez2(var ch:char;posx,posy,lung,min,max,med:integer;col:word);
procedure selez(var ch:char;posx,posy,lung,min,max,med:integer;col:word;vet:mist);
procedure finestra (xs,ys,xd,yd:integer;bordo,back:word;var porta:viewportType;
                    var P:pointer;var taglia:word);
procedure assorbi;
procedure chicca(xs,ys:integer;bordo,base:word);
procedure ombra (xd,yd,xs,ys:integer;var P:pointer;var size:word);
procedure Nombra(xd,yd:integer;P:pointer;size:word);
procedure prendipath(tit:string;var st:string;col,back:word);
function redkey:char;
function readdoppio:char;
procedure mostradir(dir:string;md,msup,ms,minf:integer);
procedure mostradir2(dir:string;xd,yd,xs,ys:integer);
procedure Errore(st:string;var ch:char);
procedure prendis(tit,tit2,ext:string;var st:string;col,back:word);
procedure prendis2(tit,tit2,ext:string;var st:string;col,back:word);
procedure prendiP(tit:string;var p3d:punto3d;col,back:word);
procedure prendir(tit:string;var num:real;col,back:word);
procedure prendin(tit:string;var num:integer;col,back:word);
procedure leggiesempi(var EsN:text;nfile,testo:string);
procedure sceltahelp(var Esn:text);
procedure crealistadir(var Indir:Listadir;var trovato:boolean;ext:string);
procedure rilasciadir(var Indir:Listadir);
procedure trovadir(P:listadir;pos:integer;var nome:string);
function lungadir(P:listadir):integer;
function avanti_indietro(ch:char):boolean;

implementation

function redkey:char;
var ch:char;
begin
  ch:=readkey;
  if ch=#45 then begin
                   closegraph;
                   clrscr;
                   write('      Goodbye...');
                   halt(0);
                 end
            else redkey:=ch;
end;

function readdoppio:char;
var ch:char;
begin
  repeat
    ch:=readkey;
  until ch<>#0;
  readdoppio:=ch;
end;

procedure assorbi;
var ch:char;                    {Elimina battute di tasti eccessive}
begin
  while keypressed do ch:=readkey;
end;

procedure leggiesempi(var EsN:text;nfile,testo:string);

const maxline=11;

var i,xput,yput:integer;
    st:string;
    ch:char;
    color,taglia:word;
    p:pointer;
    port:viewporttype;
    textinfo:textsettingstype;

begin
  if controlla(nfile) then
  begin
    ch:='#';
    getviewsettings(port);
    setviewport(0,0,getmaxx,getmaxy,clipon);
    sopramem(320,260,' <Esc> = fine, un altro tasto sfoglia il file ',taglia,p,xput,yput);
    with port do setviewport(x1,y1,x2,y2,clip);
    gettextsettings(textinfo);
    color:=getcolor;
    settextstyle(defaultfont,horizdir,1);
    settextjustify(0,0);
    assign(EsN,nfile);
    reset(EsN);
    sotto(triplexfont,Testo,lightgreen,4);
    setcolor(white);
    while not EOF(EsN) and (ch<>#27) do
    begin
      clearviewport;
      for i:=1 to maxline do
      begin
        if not EOF(EsN) then
        begin
          readln(EsN,st);
          outtextxy(20,i*15,st);
        end
      end;
      ch:=UpCase(readdoppio);
    end;
    close(EsN);
    setcolor(color);
    setviewport(0,0,getmaxx,getmaxy,clipon);
    putimage(xput,yput,p^,normalput);
    freemem(p,taglia);
    with port do setviewport(x1,y1,x2,y2,clip);
  end
  else
  begin
    settextstyle(triplexfont,horizdir,4);
    clearviewport;
    outtextxy(220,90,'Non trovo "'+nfile+'"');
    ch:=readkey;
  end;
  with textinfo do
  begin
    SetTextJustify(Horiz, Vert);
    SetTextStyle(Font, Direction, CharSize);
  end;
end;

procedure mostradir(dir:string;md,msup,ms,minf:integer);
var DirInfo: SearchRec;
    i,j:integer;
begin
  gotoxy(md+(ms-md) div 2 - (length(dir)) div 2 -5,msup);
  write('DIR: ',dir,' ');
  window(md+1,msup+1,ms-1,minf-1);
  clrscr;
  FindFirst(dir, Archive, DirInfo);
  j:=1;
  i:=1;
  while (DosError = 0)  do
  begin
    if (j<5) and (i>1)
           then  gotoxy(wherex+4,wherey)
           else
           begin
             j:=1;
             delay(100);
             writeln;
             i:=i+1;
           end;
    write(dirinfo.name:13);
    j:=j+1;
    FindNext(DirInfo);
  end;
  window(1,1,79,24);
end;

procedure finestra (xs,ys,xd,yd:integer;bordo,back:word;var porta:viewportType;
                    var P:pointer;var taglia:word);
var fillinfo:fillsettingstype;
    color:word;                         {Disegna una finestra bordata       }
begin                                   {mandando in memoria la viewport    }
  getfillsettings(fillinfo);            {precedente e lo schermo sottostante}
  setfillstyle(1,back);
  color:=getcolor;
  getviewsettings(porta);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  taglia:=imagesize(xs,ys,xd,yd);
  getmem(P,taglia);
  getimage(xs,ys,xd,yd,P^);
  setcolor(bordo);
  rectangle(xs,ys,xd,yd);
  rectangle(xs+1,ys+1,xd-1,yd-1);
  setviewport(xs+2,ys+2,xd-2,yd-2,clipon);
  clearviewport;
  bar(0,0,xd-xs-2,yd-ys-2);
  setcolor(color);
  with fillinfo do
  setfillstyle(pattern,color);
end;

procedure chicca(xs,ys:integer;bordo,base:word);
var fillinfo:fillsettingstype;
    textinfo:textsettingstype;   {Disegna il riquadro colorato posto  }
    port:viewporttype;           {nell' angolo sinistro delle finestre}
    color:word;                  {di dialogo.                         }
    st:string;
begin
  getfillsettings(fillinfo);
  getviewsettings(port);
  color:=getcolor;
  setviewport(xs-22,ys,xs,ys+20,clipon);
  setfillstyle(1,base);
  bar(0,0,22,20);
  setcolor(bordo);
  rectangle(1,1,21,19);
  line(5,5,15,10);
  line(15,10,5,15);
  line(5,15,5,5);
  setfillstyle(1,bordo);
  floodfill(7,7,getcolor);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with fillinfo do
  setfillstyle(pattern,color);
  setcolor(color);
end;

procedure ombra (xd,yd,xs,ys:integer;var P:pointer;var size:word);
var color:word;
    port:viewporttype;
    fillinfo:fillsettingstype;
begin                                    {Disegna un'ombra grigia}
  color:=getcolor;
  getviewsettings(port);
  getfillsettings(fillinfo);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  setactivepage(1);
  cleardevice;
  setcolor(white);
  setfillstyle(1,darkgray);
  bar(xd,yd,xs,ys);
  size:=imagesize(xd,yd,xs,ys);
  getmem(P,size);
  getimage(xd,yd,xs,ys,P^);
  cleardevice;
  setactivepage(0);
  putimage(xd,yd,P^,XorPut);
  with fillinfo do
  setfillstyle(pattern,color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  setcolor(color);
end;

procedure Nombra(xd,yd:integer;P:pointer;size:word);
begin
  putimage(xd,yd,P^,XorPut);             {Cancella l'ombra e rilascia memoria}
  freemem(P,size);
end;

procedure prendipath(tit:string;var st:string;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;
    textinfo:textsettingstype;
    size,color,Sombra1,Sombra2:word;
    Err:boolean;
    ch:char;                           {Finestra di dialogo per il path}
begin                                  {di ricerca                     }
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(88,134,588,224,col,back,Port,P,size);
  ombra(589,144,598,234,Pombra1,Sombra1);
  ombra(98,225,588,234,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,'Input Path');
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  textcolor(white);
  outtextxy(10,69,tit);
  riquadro(328,196,540,209);
  chicca(587,135,lightblue,lightgray);
  lamp(241,69);
  gotoxy(42,15);
  Gread(241,69,st,white);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(589,144,Pombra1,Sombra1);
  Nombra(98,225,Pombra2,Sombra2);
  putimage(88,134,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  textcolor(7);
end;

procedure mostradir2(dir:string;xd,yd,xs,ys:integer);
var dirinfo:SearchRec;
    P,Pombra1,Pombra2:pointer;
    size,color,Sombra1,Sombra2:word;      {Esegue il comando dir/w di "dir"}
    i,j,righe:integer;                    {in una finestra con ombra       }
    ch:char;
    textinfo:textsettingstype;
    porta:viewporttype;
    tit,st:string;

begin
  righe:=10;
  color:=getcolor;
  gettextsettings(textinfo);
  prendipath('Immetti albero di ricerca',st,green,white);
  finestra(xd,yd,xs,ys,lightgreen,black,porta,P,size);
  ombra(xs+1,yd+10,xs+10,ys+10,Pombra1,Sombra1);
  ombra(xd+10,ys+1,xs,ys+10,Pombra2,Sombra2);
  percent;
  setcolor(lightcyan);
  dir:=st+dir;
  FindFirst(dir, Archive, DirInfo);
  repeat
    settextstyle(defaultfont,horizdir,1);
    settextjustify(centertext,toptext);
    tit:='Directory: '+dir;
    outtextxy((xs-xd) div 2,1,tit);
    settextjustify(0,0);
    j:=1;
    i:=0;
    while (DosError=0) and (j<=righe) do
    begin
      if i>3 then
      begin
        i:=0;
        j:=J+1;
      end;
      if j>righe then
      begin
        ch:=readdoppio;
        clearviewport;
      end
      else
      begin
        outtextxy(10+i*130,15+j*14,dirinfo.name);
        i:=i+1;
        FindNext(DirInfo);
      end;
    end;
  until (DosError<>0);
  ch:=readdoppio;
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(xs+1,yd+10,Pombra1,Sombra1);
  Nombra(xd+10,ys+1,Pombra2,Sombra2);
  putimage(xd,yd,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with porta do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure Errore(st:string;var ch:char);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;
    textinfo:textsettingstype;        {Finestra di dialogo che si attiva}
    size,color,Sombra1,Sombra2:word;  {in caso di errore di I/O         }
    fillinfo:fillsettingstype;
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(100,200,540,280,white,lightred,port,P,size);
  ombra(541,210,551,290,Pombra1,Sombra1);
  ombra(110,281,540,290,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  getfillsettings(fillinfo);
  setfillstyle(1,blue);
  fillellipse(50,23,34,round(34*corr2));
  setfillstyle(1,white);
  fillellipse(50,23,29,round(29*corr2));
  setcolor(blue);
  setfillstyle(1,blue);
  fillellipse(50,18,6,12);
  fillellipse(50,38,4,round(4*corr2));
  settextstyle(triplexfont,horizdir,4);
  setcolor(white);
  outtextxy(220,18,'Errore di I/O');
  chicca(539,201,blue,white);
  settextstyle(defaultfont,horizdir,1);
  outtextxy(220,65,st);
  ch:=UpCase(readkey);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(541,210,Pombra1,Sombra1);
  Nombra(110,281,Pombra2,Sombra2);
  putimage(100,200,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  with fillinfo do
  setfillstyle(pattern,color);
end;

procedure prendis(tit,tit2,ext:string;var st:string;col,back:word);
var P,pombra1,pombra2:pointer;
    port,port2:viewporttype;           {Finestra input stringa}
    textinfo:textsettingstype;
    size,color,sombra1,sombra2:word;
    Err:boolean;
    ch:char;
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(80,120,580,210,col,back,Port,P,size);
  ombra(581,130,591,220,Pombra1,Sombra1);
  ombra(90,211,580,220,Pombra2,Sombra2);
  percent;
  repeat
    settextjustify(centertext,centertext);
    settextstyle(triplexfont,horizdir,4);
    setcolor(col);
    outtextxy(225,15,tit2);
    settextstyle(defaultfont,horizdir,1);
    settextjustify(0,centertext);
    outtextxy(10,69,tit);
    riquadro(320,182,532,195);
    chicca(579,121,back,col);
    lamp(241,69);
    gotoxy(41,14);
    Gread(241,69,st,white);
    st:=st+ext;
    Err:= not controlla(st);
    if Err then
    begin
      sound(600);
      delay(40);
      nosound;
      Errore('Non trovo '+Maiusc(st)+', vuoi vedere lista ?(S/N) ',ch);
      if ch='S' then
      begin
        setviewport(0,0,getmaxx,getmaxy,clipon);
        Nombra(581,130,Pombra1,Sombra1);
        Nombra(90,211,Pombra2,Sombra2);
        putimage(80,120,P^,normalput);
        freemem(P,size);
        mostradir2('*'+ext,55,50,575,220);
        finestra(80,120,580,210,col,back,Port2,P,size);
        ombra(581,130,591,220,Pombra1,Sombra1);
        ombra(90,211,580,220,Pombra2,Sombra2);
      end;
    end;
  until not Err;
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(581,130,Pombra1,Sombra1);
  Nombra(90,211,Pombra2,Sombra2);
  putimage(80,120,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure prendis2(tit,tit2,ext:string;var st:string;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port,port2:viewporttype;          {Finestra input stringa per il}
    textinfo:textsettingstype;        {nome del file da salvare     }
    size,color,Sombra1,Sombra2:word;
    Err:boolean;
    ch:char;
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(80,120,580,210,col,back,Port,P,size);
  ombra(581,130,591,220,Pombra1,Sombra1);
  ombra(90,211,580,220,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,tit2);
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  outtextxy(10,69,tit);
  repeat
    chicca(579,121,back,col);
    riquadro(320,182,532,195);
    lamp(241,69);
    Gread(241,69,st,white);
    st:=st+ext;
    Err:=controlla(st);
    if Err then
    begin
      sound(600);
      delay(40);
      nosound;
      Errore(Maiusc(st)+' gi presente,sovrascrivo ?(S/N) ',ch);
      if ch='S' then
    end;
  until (not Err) or (ch='S');
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(581,130,Pombra1,Sombra1);
  Nombra(90,211,Pombra2,Sombra2);
  putimage(80,120,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure prendiP(tit:string;var p3d:punto3d;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;               {Finestra input punto 3d}
    textinfo:textsettingstype;
    size,color,Sombra1,Sombra2:word;
    Err:boolean;
    st:string;
    cd1,cd2,cd3:integer;

procedure stpunto(st:string;var num1,num2,num3:real;var cd1,cd2,cd3:integer);

const maxcar=23;
type parola=array[1..maxcar] of char;
var stnum1,stnum2,stnum3:string;
    par:parola;
    i:integer;

procedure stinum(par:parola;var stnum:string;var i:integer);
begin
  stnum:='';
  while (i<=maxcar) and (par[i]<>' ')  and (par[i]<>#1) do
  begin
    stnum:=stnum+par[i];
    i:=i+1;
  end;
  while (par[i]=' ') do
    i:=i+1;
end;

begin
  for i:=1 to maxcar do par[i]:=#1;
  for i:=1 to length(st) do
  if st[i]<>#1 then par[i]:=st[i];
  i:=1;
  stinum(par,stnum1,i);
  stinum(par,stnum2,i);
  stinum(par,stnum3,i);
  val(stnum1,num1,cd1);
  val(stnum2,num2,cd2);
  val(stnum3,num3,cd3);
end;

{Inizio Procedura Principale}
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(80,120,580,210,col,back,Port,P,size);
  ombra(581,130,591,220,Pombra1,Sombra1);
  ombra(90,211,580,220,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,'Input Punto 3d');
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  outtextxy(10,69,tit);
  repeat
    riquadro(320,182,532,195);
    chicca(579,121,back,col);
    lamp(241,69);
    Gread(241,69,st,white);
    with p3d do
    stpunto(st,x,y,z,cd1,cd2,cd3);
    Err:=(cd1<>0) or (cd2<>0) or (cd3<>0);
    if Err then
    begin
      sound(400);
      delay(40);
      nosound;
    end;
  until not Err;
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(581,130,Pombra1,Sombra1);
  Nombra(90,211,Pombra2,Sombra2);
  putimage(80,120,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure prendir(tit:string;var num:real;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;
    textinfo:textsettingstype;           {Finestra dialogo numero reale}
    size,color,Sombra1,Sombra2:word;
    Err:boolean;
    stnum:string;
    code:integer;
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(80,120,580,210,col,back,Port,P,size);
  ombra(581,130,591,220,Pombra1,Sombra1);
  ombra(90,211,580,220,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,'Input Numero Reale');
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  outtextxy(10,69,tit);
  repeat
    riquadro(320,182,532,195);
    chicca(579,121,back,col);
    lamp(241,69);
    Gread(241,69,stnum,white);
    val(stnum,num,code);
    Err:=(code<>0);
    if Err then
    begin
      sound(400);
      delay(40);
      nosound;
    end;
  until not Err;
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(581,130,Pombra1,Sombra1);
  Nombra(90,211,Pombra2,Sombra2);
  putimage(80,120,P^,normalput);
  freemem(P,size);
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  percent;
end;

procedure prendin(tit:string;var num:integer;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;
    textinfo:textsettingstype;
    size,color,Sombra1,Sombra2:word;     {Finestra input numero intero}
    Err:boolean;
    stnum:string;
    code:integer;
begin
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(80,120,580,210,col,back,Port,P,size);
  ombra(581,130,591,220,Pombra1,Sombra1);
  ombra(90,211,580,220,Pombra2,Sombra2);
  percent;
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,'Input Numero Intero');
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  outtextxy(10,69,tit);
  repeat
    riquadro(320,182,532,195);
    chicca(579,121,back,col);
    lamp(241,69);
    Gread(241,69,stnum,white);
    val(stnum,num,code);
    Err:=(code<>0);
    if Err then
    begin
      sound(800);
      delay(40);
      nosound;
    end;
  until not Err;
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(581,130,Pombra1,Sombra1);
  Nombra(90,211,Pombra2,Sombra2);
  putimage(80,120,P^,normalput);
  freemem(P,size);
  percent;
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
end;

procedure selez(var ch:char;posx,posy,lung,min,max,med:integer;col:word;vet:mist);
var larg:word;
    size:word;
    p:pointer;
    i:integer;
    FillInfo: FillSettingsType;

function checka (i:integer;ch:char;vet:mist):boolean;
begin
  if (ch>'0') and (ch<'9') and (vet[i]<>0) then checka:=true
  else if (vet[i]<>0) and (ch=#13) or (ch=#27) then checka:=true
                                               else checka:=false;
end;

procedure carat(i:integer;var ch:char);
begin
  if (i<=9) and ((ch<'0') or (ch>'9'))  and (ch<>#27) then
  ch:=char(i+ord('0'))
  else if (i>9) and ((ch<'0') or (ch>'9')) and (ch<>#27) then ch:='0';
end;

begin
  i:=1;
  getfillsettings(fillinfo);
  setfillstyle(solidfill,col);
  larg:=textheight('Mamma');
  setactivepage(1);
  cleardevice;
  bar(posx,1,posx+lung,1+larg);
  size:=imagesize(posx,1,posx+lung,1+larg);
  getmem(p,size);
  getimage(posx,1,posx+lung,1+larg,P^);
  cleardevice;
  setactivepage(0);
  putimage(posx,posy,p^,Xorput);
  repeat
    ch:=UpCase(readkey);
    case ch of
    #72:if i>min then
        begin
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
          i:=i-1;
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
        end;
    #80:if i<max then
        begin
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
          i:=i+1;
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
        end;
    end;
  until checka(i,ch,vet);
  carat(i,ch);
  freemem(P,size);
  with fillinfo do
  setfillstyle(pattern,color);
end;

procedure selez2(var ch:char;posx,posy,lung,min,max,med:integer;col:word);
var larg:word;
    size:word;
    p:pointer;
    i:integer;
    FillInfo: FillSettingsType;

function carat(i:integer):char;
begin
  carat:=chr(ord('1')+i-1);
end;

begin
  i:=1;
  getfillsettings(fillinfo);
  setfillstyle(solidfill,col);
  larg:=textheight('Mamma e Gigiop');
  setactivepage(1);
  cleardevice;
  bar(posx,1,posx+lung,1+larg);
  size:=imagesize(posx,1,posx+lung,1+larg);
  getmem(p,size);
  getimage(posx,1,posx+lung,1+larg,P^);
  cleardevice;
  setactivepage(0);
  putimage(posx,posy,p^,Xorput);
  repeat
    ch:=UpCase(readkey);
    case ch of
    #72:if i>min then
        begin
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
          i:=i-1;
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
        end;
    #80:if i<max then
        begin
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
          i:=i+1;
          putimage(posx,posy+(i-1)*(larg+med div 2),p^,Xorput);
        end;
    end;
  until (ch=#13) or (ch=#27) or (ch=#45) or (ch=#59);
  if (ch<>#27) and (ch<>#45) and (ch<>#59) then ch:=carat(i);
  freemem(P,size);
  with fillinfo do
  setfillstyle(pattern,color);
end;

procedure sceltahelp(var Esn:text);
var P,s1,s2:pointer;
    size,t1,t2,colore:word;
    porta,old:viewporttype;
    ch:char;
    textinfo:textsettingstype;
    fillinfo:fillsettingstype;

begin
  colore:=getcolor;
  getviewsettings(old);
  gettextsettings(textinfo);
  getfillsettings(fillinfo);
  setfillstyle(fillinfo.pattern,white);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  settextstyle(defaultfont,horizdir,1);
  setcolor(blue);
  bar(130,80,510,180);
  rectangle(131,81,509,179);
  rectangle(132,82,508,178);
  ombra(511,90,520,190,s1,t1);
  ombra(140,181,510,190,s2,t2);
  freemem(s1,t1);
  freemem(s2,t2);
  setviewport(133,83,507,177,clipon);
  outtextxy(187,11,'- Help on line -');
  line(0,14,474,14);
  settextjustify(0,0);
  outtextxy(20,32,'- Esempi Notevoli');
  outtextxy(20,43,'- Descrizione casi particolari');
  outtextxy(20,54,'- Generalit');
  outtextxy(20,65,'- Registrazione dati');
  outtextxy(20,76,'- Codifiche d''archivio');
  outtextxy(20,87,'- Manuale semplificato');
  sotto(triplexfont,'<Esc> per Uscire',yellow,4);
  percent;
  selez2(ch,8,23,358,1,6,7,red);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  with old do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    SetTextJustify(Horiz, Vert);
    SetTextStyle(Font, Direction, CharSize);
  end;
  with fillinfo do setfillstyle(pattern,color);
  setcolor(colore);
  if ch<>#27 then sopra(320,25,smallfont,4,'      Help      ',yellow,blue);
  case ch of
  '1':leggiesempi(Esn,'Paiuto.doc','Esempi Notevoli');
  '2':leggiesempi(Esn,'Casi.doc','Percorso guidato');
  '3':begin
        clearviewport;
        terna(ch);
        if ch<>#27 then
        legenda(ch);
        if ch<>#27 then
        leggiesempi(Esn,'Hlp.doc','Generalit');
      end;
  '4':leggiesempi(Esn,'Salva.doc','Registrazione Dati');
  '5':begin
        setcolor(lightcyan);
        sotto(triplexfont,'Codifiche per i file di archivio',lightgreen,3);
        settextstyle(defaultfont,horizdir,1);
        clearviewport;
        outtextxy(220,20,'Qualora si desideri redarre gli archivi contenenti le');
        outtextxy(220,40,'informazioni relative ai solidi (vertici e spigoli) ');
        outtextxy(220,60,'con un editore di testo esterno, come caldamente con-');
        outtextxy(220,80,'siglio,  necessario conoscere le regole di codifica');
        outtextxy(220,100,'utilizzate. Il dato fondamentale, il punto 3d, va');
        outtextxy(220,120,'scritto come tre numeri allineati separati da uno');
        outtextxy(220,140,'spazio. Ciascuna riga deve contenere un unico dato.');
        outtextxy(220,160,'Segue ora la sequenza corretta dei dati:');
        ch:=readkey;
        if ch<>#27 then
        begin
          clearviewport;
          setcolor(white);
          outtextxy(220,20,'Prima riga -->numero dei vertici (intero);');
          outtextxy(220,40,'Linee successive -->elenco dei vertici;   ');
          setcolor(lightcyan);
          outtextxy(220,60,'Segue quindi il numero dei vertici legati con altri ');
          outtextxy(220,80,'per formare gli spigoli. Elenco di questi vertici:  ');
          setcolor(white);
          outtextxy(220,100,'vertice                                           ');
          outtextxy(220,120,'coordinate vertice                                ');
          outtextxy(220,140,'legame_                                           ');
          outtextxy(220,160,'numero vertici collegati e, a capo, il loro elenco');
          setcolor(lightcyan);
          ch:=readkey;
        end;
        if ch<>#27 then
        begin
          clearviewport;
          outtextxy(220,20,'E'' possibile utilizzare la medesima tecnica anche per');
          outtextxy(220,40,'scrivere nuovi moti, ma  pi conveniente editare un');
          outtextxy(220,60,'file di moto (*.fct) solo per corregere le funzioni.');
          outtextxy(220,80,'Le regole sono simili a quelle gi viste: nome della');
          outtextxy(220,100,'grandezza da variare,tipo di funzione,valore dei pa-');
          outtextxy(220,120,'rametri. Ricordo che le funzioni devono essere sei.');
          outtextxy(220,140,'Per un esame pi approfondito si rimanda al manuale.');
          setcolor(white);
          outtextxy(220,170,'P.S. I file dei solidi devono avere estensione .dwg .');
          setcolor(lightcyan);
          ch:=readkey;
        end;
        {if ch<>#27 then leggiesempi(Esn,'Cody.doc','Codifiche Dati');}
      end;
  '6':leggiesempi(Esn,'Manual.doc','Manuale semplificato');
  end;
  
end;

procedure LDirwrite(var Indir:listadir;st:string);
var Prec,Att,P:listadir;
    Fine:boolean;

begin
  new(P);
  P^.nome:=st;
  Fine:=false;
  Prec:=nil;
  Att:=Indir;
  while (Att<>nil) and not Fine do
  if (Att^.nome > st) then fine:=true
                      else
                      begin
                        Prec:=Att;
                        Att:=Att^.succ;
                      end;
  if Prec=nil then              {siamo all'inizio della lista}
  begin
    P^.succ:=Indir;
    Indir:=P;
  end
  else
  begin
    P^.succ:=Att;
    Prec^.succ:=P;
  end
end;

procedure crealistadir(var Indir:Listadir;var trovato:boolean;ext:string);

var Dirinfo:SearchRec;

begin
  Indir:=nil;
  FindFirst(ext, Archive, DirInfo);
  if DosError=0 then trovato:=true;
  while (DosError = 0) do
  begin
    LDirwrite(Indir,Dirinfo.name);
    FindNext(DirInfo);
  end;
end;

procedure rilasciadir(var Indir:Listadir);

var P:listadir;

begin
  while Indir<>nil do
  begin
    P:=Indir;
    Indir:=Indir^.succ;
    dispose(P);
  end;
end;

procedure trovadir(P:listadir;pos:integer;var nome:string);
var i:integer;
begin
  i:=1;
  while (P<>nil) and (i<pos) do
  begin
    P:=P^.succ;
    i:=i+1;
  end;
  nome:=P^.nome;
end;

function lungadir(P:listadir):integer;
var i:integer;
begin
  i:=0;
  while(P<>nil) do
  begin
    i:=i+1;
    P:=P^.succ;
  end;
  lungadir:=i;
end;

function avanti_indietro(ch:char):boolean;
begin
  avanti_indietro:=(ch=#77) or (ch=#75) or (ch=#13)
end;

end.