unit marcodos;

interface

uses graph,dos,crt;

procedure finestra (xs,ys,xd,yd:integer;bordo,back:word;var porta:viewportType;
                    var P:pointer;var taglia:word);
procedure riquadro(xs,ys,xd,yd:integer);
procedure lamp(x,y:integer);
procedure chicca(xs,ys:integer;bordo,base:word);
procedure ombra (xd,yd,xs,ys:integer;var P:pointer;var size:word);
procedure Nombra(xd,yd:integer;P:pointer;size:word);
procedure prendipath(tit:string;var st:string;col,back:word);
function controlla (st:string):boolean;
procedure mostradir(dir:string;md,msup,ms,minf:integer);

implementation

function controlla (st:string):boolean;
var
  S: PathStr;
begin
  S := FSearch(st,GetEnv('PATH'));
  if S = '' then
  begin
    controlla:=false;
  end
  else controlla:=true;
end;

procedure mostradir(dir:string;md,msup,ms,minf:integer);
var DirInfo: SearchRec;
    i,j:integer;
begin
  gotoxy(md+(ms-md) div 2 - (length(dir)) div 2 -5,msup);
  write('DIR: ',dir,' ');
  window(md+1,msup+1,ms-1,minf-1);
  clrscr;
  FindFirst(dir, Archive, DirInfo);
  j:=1;
  i:=1;
  while (DosError = 0)  do
  begin
    if (j<5) and (i>1)
           then  gotoxy(wherex+4,wherey)
           else
           begin
             j:=1;
             delay(100);
             writeln;
             i:=i+1;
           end;
    write(dirinfo.name:13);
    j:=j+1;
    FindNext(DirInfo);
  end;
  window(1,1,79,24);
end;
procedure finestra (xs,ys,xd,yd:integer;bordo,back:word;var porta:viewportType;
                    var P:pointer;var taglia:word);
var fillinfo:fillsettingstype;
    color:word;                         {Disegna una finestra bordata       }
begin                                   {mandando in memoria la viewport    }
  getfillsettings(fillinfo);            {precedente e lo schermo sottostante}
  setfillstyle(1,back);
  color:=getcolor;
  getviewsettings(porta);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  taglia:=imagesize(xs,ys,xd,yd);
  getmem(P,taglia);
  getimage(xs,ys,xd,yd,P^);
  setcolor(bordo);
  rectangle(xs,ys,xd,yd);
  rectangle(xs+1,ys+1,xd-1,yd-1);
  setviewport(xs+2,ys+2,xd-2,yd-2,clipon);
  clearviewport;
  floodfill(5,5,getcolor);
  setcolor(color);
  with fillinfo do
  setfillstyle(pattern,color);
end;

procedure riquadro(xs,ys,xd,yd:integer);
var port:viewporttype;
begin                          {Disegna un riquadro nero (cord. assolute)}
  getviewsettings(port);
  setviewport(xs,ys,xd,yd,clipon);
  clearviewport;
  with port do
  setviewport(x1,y1,x2,y2,clip);
end;

procedure lamp(x,y:integer);
var time:integer;
    info:textsettingstype;    {Emula il cursore lampeggante del modo testo}
    color:word;
begin
  time:=100;
  color:=getcolor;
  gettextsettings(info);
  settextstyle(defaultfont,horizdir,1);
  repeat
    setcolor(white);
    outtextxy(x,y,'_');
    delay(time);
    setcolor(black);
    outtextxy(x,y,'_');
    delay(time)
  until keypressed;
  setcolor(black);
  outtextxy(x,y,'_');
  setcolor(color);
  with info do
  settextstyle(font,direction,charsize);
end;

procedure chicca(xs,ys:integer;bordo,base:word);
var fillinfo:fillsettingstype;
    textinfo:textsettingstype;   {Disegna il riquadro colorato posto  }
    port:viewporttype;           {nell' angolo sinistro delle finestre}
    color:word;                  {di dialogo.                         }
    st:string;
begin
  getfillsettings(fillinfo);
  getviewsettings(port);
  color:=getcolor;
  setviewport(xs-22,ys,xs,ys+20,clipon);
  setfillstyle(1,base);
  floodfill(2,2,getcolor);
  setcolor(bordo);
  rectangle(1,1,21,19);
  line(5,5,15,10);
  line(15,10,5,15);
  line(5,15,5,5);
  setfillstyle(1,bordo);
  floodfill(7,7,getcolor);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with fillinfo do
  setfillstyle(pattern,color);
  setcolor(color);
end;

procedure ombra (xd,yd,xs,ys:integer;var P:pointer;var size:word);
var color:word;
    port:viewporttype;
    fillinfo:fillsettingstype;
begin                                    {Disegna un'ombra grigia}
  color:=getcolor;
  getviewsettings(port);
  getfillsettings(fillinfo);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  setactivepage(1);
  cleardevice;
  setcolor(white);
  setfillstyle(1,darkgray);
  rectangle(xd-1,yd-1,xs+1,ys+1);
  floodfill(xd+1,yd+1,getcolor);
  size:=imagesize(xd,yd,xs,ys);
  getmem(P,size);
  getimage(xd,yd,xs,ys,P^);
  cleardevice;
  setactivepage(0);
  putimage(xd,yd,P^,XorPut);
  with fillinfo do
  setfillstyle(pattern,color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  setcolor(color);
end;

procedure Nombra(xd,yd:integer;P:pointer;size:word);
begin
  putimage(xd,yd,P^,XorPut);             {Cancella l'ombra e rilascia memoria}
  freemem(P,size);
end;

procedure prendipath(tit:string;var st:string;col,back:word);
var P,Pombra1,Pombra2:pointer;
    port:viewporttype;
    textinfo:textsettingstype;
    size,color,Sombra1,Sombra2:word;
    Err:boolean;
    ch:char;                           {Finestra di dialogo per il path}
begin                                  {di ricerca                     }
  color:=getcolor;
  gettextsettings(textinfo);
  finestra(88,134,588,224,col,back,Port,P,size);
  ombra(589,144,598,234,Pombra1,Sombra1);
  ombra(98,225,588,234,Pombra2,Sombra2);
  settextjustify(centertext,centertext);
  settextstyle(triplexfont,horizdir,4);
  setcolor(col);
  outtextxy(225,15,'Input Path');
  settextstyle(defaultfont,horizdir,1);
  settextjustify(0,centertext);
  textcolor(white);
  outtextxy(10,69,tit);
  riquadro(328,196,518,209);
  chicca(587,135,lightblue,lightgray);
  lamp(241,69);
  gotoxy(42,15);
  readln(st);
  setviewport(0,0,getmaxx,getmaxy,clipon);
  Nombra(589,144,Pombra1,Sombra1);
  Nombra(98,225,Pombra2,Sombra2);
  putimage(88,134,P^,normalput);
  freemem(P,size);
  setcolor(color);
  with port do
  setviewport(x1,y1,x2,y2,clip);
  with textinfo do
  begin
    settextjustify(horiz,vert);
    settextstyle(font,direction,charsize);
  end;
  textcolor(7);
end;

end.